<script setup>
import { useForm } from '~/utils'

useSeoMeta({
  title: '表單驗證',
})

const loading = ref(false)

const { formRef, formModel, formRules, formError, submit } = useForm({
  account: '',
  password: '',
}, {
  account: {
    required: true,
    message: '請輸入帳號',
  },
  password: {
    required: true,
    message: '請輸入密碼',
  },
})

function handleSubmit() {
  loading.value = true

  submit(() => {
    // do something.
  }, () => {
    loading.value = false
  })
}
</script>

<template>
  <div class="relative">
    <div class="sticky left-0 right-0 top-0 z-100 flex items-center gap-4 bg-light p-2 shadow dark:bg-dark dark:color-light">
      <RouterLink class="absolute flex items-center gap-2 rounded bg-green/25 p-2 transition hover:bg-green/50" to="/examples">
        <i class="i-carbon-arrow-left"></i>
        Back
      </RouterLink>
      <h2 class="flex-grow py-2 text-center text-2xl">
        Form
      </h2>
    </div>
    <div class="m-auto max-w-screen-sm py-4">
      <NForm
        ref="formRef"
        label-placement="top"
        label-width="150"
        label-align="left"
        :model="formModel"
        :rules="formRules"
        :show-require-mark="false"
      >
        <NFormItem label="帳號" path="account">
          <NInput
            v-model:value="formModel.account"
            placeholder=""
            :input-props="{ autocomplete: 'off' }"
          />
        </NFormItem>
        <NFormItem label="密碼" path="password" :feedback="formError.password ? undefined : '請輸入6~8碼半型英文與數字的組合'">
          <NInput
            v-model:value="formModel.password"
            type="password"
            show-password-on="click"
            placeholder=""
            :maxlength="8"
            :input-props="{ autocomplete: 'off' }"
          />
        </NFormItem>
        <div>
          <NButton :loading="loading" type="primary" class="mt-5 w-full" @click="handleSubmit">
            登入
          </NButton>
        </div>
        <div class="h-60px w-full flex items-center justify-center px-4 lg:px-10">
          <ul class="w-full flex flex-wrap items-center justify-center children:(b-r-width-1 border-r-solid)">
            <li class="px-20px">
              <RouterLink to="/examples" title="忘記密碼" class="flex items-center justify-center">
                忘記密碼
              </RouterLink>
            </li>
            <li class="px-20px b-r-none!">
              <RouterLink to="/examples" title="註冊會員" class="flex items-center justify-center">
                <i class="i-icon-park-twotone-hand-right mr-2"></i>註冊會員
              </RouterLink>
            </li>
          </ul>
        </div>
      </NForm>
    </div>
  </div>
</template>
